# evaluation
auc<-function(pred.table, test.table){
	valid.rows<-intersect(rownames(test.table), rownames(pred.table))
	valid.cols<-intersect(colnames(test.table), colnames(pred.table))
	valid.test.table<-test.table[valid.rows, valid.cols]
	predict.value<-as.vector(pred.table[valid.rows, valid.cols])
	predict.order<-order(predict.value, decreasing=T)
	test.vector<-as.vector(valid.test.table)
	total.value<-sum(test.vector)
	surv.points<-100
	surv<-sapply(1:surv.points, function(i) sum(test.vector[predict.order[1:(i*floor(length(test.vector)/surv.points))]])/total.value)
	auc<-sum(sapply(1:surv.points, function(i)
	(i/surv.points-(i-1)/surv.points)*
	(sum(test.vector[predict.order[1:(i*floor(length(test.vector)/surv.points))]])/total.value
	+
	sum(test.vector[predict.order[1:((i-1)*floor(length(test.vector)/surv.points))]])/total.value)/2
	))
  return(auc)
}
surv.p<-function(pred.table, test.table, p){
	valid.rows<-intersect(rownames(test.table), rownames(pred.table))
	valid.cols<-intersect(colnames(test.table), colnames(pred.table))
	#print(c("number of valid rows:", length(valid.rows)))
	#print(c("number of valid cols:", length(valid.cols)))
	valid.test.table<-test.table[valid.rows, valid.cols]
	predict.value<-as.vector(pred.table[valid.rows, valid.cols])
	predict.order<-order(predict.value, decreasing=T)
	test.vector<-as.vector(valid.test.table)
	total.value<-sum(test.vector)
	surv.points<-100
	surv<-sapply(1:surv.points, function(i) sum(test.vector[predict.order[1:(i*floor(length(test.vector)/surv.points))]])/total.value)
    return(surv[p]);
}
eval<-function(pred.table, train.table, test.table){
	res.eval<-c(mae(pred.table, train.table), rmse(pred.table, train.table), auc(pred.table, test.table), surv.p(pred.table, test.table, 20), surv.p(pred.table, test.table, 50), surv.p(pred.table, test.table, 80))
	print(res.eval)
	return(res.eval)
}

eval.return<-function(pred.table){
	valid.rows<-intersect(rownames(test.table), rownames(pred.table))
	valid.cols<-intersect(colnames(test.table), colnames(pred.table))
	valid.test.table<-test.table[valid.rows, valid.cols]
	predict.value<-as.vector(pred.table[valid.rows, valid.cols])
	predict.order<-order(predict.value, decreasing=T)
	test.vector<-as.vector(valid.test.table)
	total.value<-sum(test.vector)
	surv.points<-100
	surv<-sapply(1:surv.points, function(i) sum(test.vector[predict.order[1:(i*floor(length(test.vector)/surv.points))]])/total.value)
	auc<-sum(sapply(1:surv.points, function(i)
	(i/surv.points-(i-1)/surv.points)*
	(sum(test.vector[predict.order[1:(i*floor(length(test.vector)/surv.points))]])/total.value
	+
	sum(test.vector[predict.order[1:((i-1)*floor(length(test.vector)/surv.points))]])/total.value)/2
	))
	return(surv)
}
mae<-function(pred.table, test.table){
	valid.rows<-intersect(rownames(test.table), rownames(pred.table))
	valid.cols<-intersect(colnames(test.table), colnames(pred.table))
	valid.test.table<-test.table[valid.rows, valid.cols]
	predict.value<-as.vector(pred.table[valid.rows, valid.cols])
	test.vector<-as.vector(valid.test.table)
	return(mean(abs(predict.value[test.vector != 0]-test.vector[test.vector != 0])))
}
rmse<-function(pred.table, test.table){
	valid.rows<-intersect(rownames(test.table), rownames(pred.table))
	valid.cols<-intersect(colnames(test.table), colnames(pred.table))
	valid.test.table<-test.table[valid.rows, valid.cols]
	predict.value<-as.vector(pred.table[valid.rows, valid.cols])
	test.vector<-as.vector(valid.test.table)
	return(sqrt(mean((predict.value[test.vector != 0]-test.vector[test.vector != 0])^2)))
}
